#ifndef _WINFILE_H_
#define _WINFILE_H_


class WinFile {

private:
	enum { WF_BUFFERSIZE = 65536 };

	unsigned char   mBuffer[WF_BUFFERSIZE];
	LARGE_INTEGER   mPos;
	LARGE_INTEGER   mSize;
	HANDLE          mHandle;

	void Refresh();

	LPSTR WcharToAnsi(LPCWSTR lpszWchar) const;

	HANDLE DualCreateFile(
		LPCWSTR                 lpFileName,
		DWORD                   dwDesiredAccess,
		DWORD                   dwShareMode,
		LPSECURITY_ATTRIBUTES   lpSecurityAttributes,
		DWORD                   dwCreationDisposition,
		DWORD                   dwFlagsAndAttributes,
		HANDLE                  hTemplateFile
	) const;

public:
	WinFile();
	~WinFile();

	bool    Open(const wchar_t *lpszFileName);

	__int64 Size() const      { return mSize.QuadPart; }
	__int64 Pos() const       { return mPos.QuadPart;  }
	bool    EndOfFile() const { return (mPos.QuadPart >= mSize.QuadPart); }

	bool    Seek(__int64 iAbsPos);

	int     Read(void *lpBuffer, int iBytes);
	int     ReadByte();
};


#endif	// _WINFILE_H_
